<?php

namespace app\admin\controller;

use app\common\controller\Backend;
use think\Db;
/**
 * 提现申请
 *
 * @icon fa fa-circle-o
 */
class Takecash extends Backend
{
    
    /**
     * Takecash模型对象
     * @var \app\admin\model\Takecash
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\Takecash;
        $this->view->assign("statusList", $this->model->getStatusList());
    }

    public function import()
    {
        parent::import();
    }

    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */
    

    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['user'])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('user')->visible(['username','nickname']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }

    /**
     * 审核
     */
    public function audit(){
        $id = input('id');
        $info = Db::name('take_cash')
            ->where('id',$id)
            ->find();

        if ($this->request->isPost()) {
            $status = input('status',0);
            $data = [
                'status' => $status,
                'auditremark' => input('auditremark'),
                'audittime' => time(),
                'updatetime' => time(),
            ];
            Db::startTrans();

            $rs = Db::name('take_cash')->where('id',$id)->update($data);


            //tag任务赠送金币
            if($status == 1){
                //扣钱
                $wallet_rs = model('wallet')->lockChangeAccountRemain($info['user_id'],'money',-$info['number'],15,'提现:'.$info['number'],'take_cash',$info['id']);
                if($wallet_rs['status'] === false){
                    Db::rollback();
                    $this->error($wallet_rs['msg']);
                }
                //系统消息
                $msg_id = \app\common\model\Message::addMessage($info['user_id'],'提现审核','提现审核已经审核通过');
            }elseif($status == 2){
                //系统消息
                $msg_id = \app\common\model\Message::addMessage($info['user_id'],'提现审核','提现审核审核不通过');
            }
            Db::commit();

            $this->success('审核完成');
        }

        $this->assign('row',$info);
        return $this->view->fetch();
    }

}
